//----------------------------------------------------------------------------
//	HEADER:	MapRep.h
//	AUTHOR:	Ian Taylor
//	NOTES:	Header file of Map report data
//----------------------------------------------------------------------------

// Packed data structure (32-bit alignment)
typedef UINT32 UBits;
typedef INT32 SBits;
typedef struct _MAPNUMPACKED
{
	UBits c1a:5, c1b:5;			// ISO-2
	UBits c2a:5, c2b:5, c2c:5;	// ISO-3
	UBits d5m:6;				// Timezone (minutes)

	UBits c3a:5, c3b:5;			// FIPS
	UBits c4a:5, c4b:5;			// IANA
	UBits d1:1;					// Visited
	UBits d3:11;				// ITU Calling

	UBits c5a:5, c5b:5, c5c:5;	// UN vehicle
	UBits c6a:5, c6b:5, c6c:5;	// IOC
	UBits d4:2;					// Colour

	UBits d2:10;				// ISO
	UBits v01a:10;				// Coastline (km)
	UBits v01b:2;				// Coastline (km)
	UBits v02a:10;				// Highest point (m)

	UBits v02b:1;				// Highest point (m)
	UBits v03b:1;				// Lowest point (m)
	UBits v04a:10;				// Total freshwater withdrawal (km/year)
	UBits v05a:10;				// Irrigated land (km)
	UBits v06a:10;				// Land area (km)

	UBits v04b:2;				// Total freshwater withdrawal (km/year)
	UBits v05b:2;				// Irrigated land (km)
	UBits v06b:3;				// Land area (km)
	UBits v07a:10;				// Land boundaries (km)
	UBits v07b:2;				// Land boundaries (km)
	UBits v08a:10;				// Land use - Arable  (km)
	UBits v08b:3;				// Land use - Arable  (km)

	UBits v09a:10;				// Land use - Permanent crops (km)
	UBits v11a:10;				// Total renewable water resources (km)
	UBits v12a:10;				// Water area (km)
	UBits v12b:2;				// Water area (km)

	UBits v11b:2;				// Total renewable water resources (km)
	UBits v13a:10;				// Population
	UBits v14:10;				// Age structure 0-14 years(%)
	UBits v15:10;				// Age structure 15-64 years(%)

	UBits v09b:3;				// Land use - Permanent crops (km)
	UBits v13b:3;				// Population
	UBits v17:10;				// Life expectancy at birth - total(years)
	UBits v18a:10;				// HIV/AIDS - adult prevalence rate(%)
	UBits v21b:3;				// Births per year
	UBits v22b:3;				// Deaths per year

	UBits v18b:1;				// HIV/AIDS - adult prevalence rate(%)
	UBits v20:10;				// Median age - total (years)
	UBits v21a:10;				// Births per year
	UBits v22a:10;				// Deaths per year
	UBits v38b:1;				// Airports - with paved runways - total

	UBits v25:10;				// Sex ratio - 65 years and over (m/f)
	UBits v26:10;				// Sex ratio - at birth (m/f)
	UBits v27:10;				// Sex ratio - under 15 years (m/f)
	UBits v31b:2;				// Infant mortality rate (/1000)

	UBits v28:10;				// Sex ratio 15-64 years (m/f)
	UBits v29:10;				// Sex ratio - total population (m/f)
	UBits v31a:10;				// Infant mortality rate (/1000)
	UBits v42b:2;				// Pipelines (km)

	UBits v32:10;				// Total fertility rate (children born/woman)
	UBits v34a:10;				// Urban population
	UBits v35:10;				// Probability Reaching 65 Female
	UBits v39b:1;				// Airports - with unpaved runways - total
	UBits v41b:1;				// Merchant marine (ships)

	UBits v34b:3;				// Urban population
	UBits v36:10;				// Probability Reaching 65 Male
	UBits v38a:10;				// Airports - with paved runways - total
	UBits v48b:3;				// Budget expenditures
	UBits v49b:3;				// Budget revenues
	UBits v51b:3;				// Debt - external

	UBits v39a:10;				// Airports - with unpaved runways - total
	UBits v40:10;				// Heliports
	UBits v41a:10;				// Merchant marine (ships)
	UBits v43b:2;				// Railways (km)
	
	UBits v42a:10;				// Pipelines (km)
	UBits v43a:10;				// Railways (km)
	UBits v44a:10;				// Roadways (km)
	UBits v44b:2;				// Roadways (km)

	UBits v45a:10;				// Waterways (km)
	UBits v45b:2;				// Waterways (km)
	UBits v46:10;				// Primary School Attendance
	UBits v47:10;				// Literacy - total(%)

	UBits v48a:10;				// Budget expenditures
	UBits v49a:10;				// Budget revenues
	UBits v52b:3;				// Imports
	UBits v53b:3;				// Exports
	UBits v55b:3;				// GDP - official exchange rate
	UBits v56b:3;				// GDP - purchasing power parity

	UBits v51a:10;				// Debt - external
	UBits v52a:10;				// Imports
	UBits v57b:3;				// Public debt
	UBits v58b:3;				// Reserves of foreign exchange and gold
	UBits v59b:3;				// Military expenditures
	UBits v60b:3;				// Education expenditures

	UBits v53a:10;				// Exports
	UBits v55a:10;				// GDP - official exchange rate
	UBits v67b:3;				// Labor force
	UBits v71b:3;				// Population below poverty line
	UBits v73b:3;				// Manpower available for military service
	UBits v74b:3;				// Manpower fit for military service

	UBits v56a:10;				// GDP - purchasing power parity
	UBits v57a:10;				// Public debt
	UBits v58a:10;				// Reserves of foreign exchange and gold

	UBits v59a:10;				// Military expenditures
	UBits v60a:10;				// Education expenditures
	UBits v61:10;				// GDP - composition by sector - agriculture (%)

	UBits v62:10;				// GDP - composition by sector - industry (%)
	UBits v67a:10;				// Labor force
	UBits v68:10;				// Labor force - by occupation - agriculture (%)

	UBits v69:10;				// Labor force - by occupation - industry (%)
	UBits v71a:10;				// Population below poverty line
	UBits v72:10;				// Unemployment rate (%)

	UBits v73a:10;				// Manpower available for military service
	UBits v74a:10;				// Manpower fit for military service
	UBits v75a:10;				// Manpower reaching militarily significant age annually

	UBits v75b:3;				// Manpower reaching militarily significant age annually
	UBits v76:10;				// Human Development Index
	UBits v77a:10;				// Electricity - consumption (kWh)
	UBits v77b:3;				// Electricity - consumption (kWh)
	UBits v78b:3;				// Electricity - exports (kWh)
	UBits v79b:3;				// Electricity - imports (kWh)

	UBits v78a:10;				// Electricity - exports (kWh)
	UBits v79a:10;				// Electricity - imports (kWh)
	UBits v80b:3;				// Electricity - production (kWh)
	UBits v81b:3;				// Natural gas - consumption (cu m)
	UBits v82b:3;				// Natural gas - exports (cu m)
	UBits v83b:3;				// Natural gas - imports (cu m)

	UBits v80a:10;				// Electricity - production (kWh)
	UBits v81a:10;				// Natural gas - consumption (cu m)
	UBits v82a:10;				// Natural gas - exports (cu m)

	UBits v83a:10;				// Natural gas - imports (cu m)
	UBits v84a:10;				// Natural gas - production (cu m)
	UBits v84b:3;				// Natural gas - production (cu m)
	UBits v85b:3;				// Natural gas - proved reserves (cu m)
	UBits v86b:3;				// Oil - consumption (bbl / Day)
	UBits v87b:3;				// Oil - exports (bbl / Day)

	UBits v85a:10;				// Natural gas - proved reserves (cu m)
	UBits v86a:10;				// Oil - consumption (bbl / Day)
	UBits v87a:10;				// Oil - exports (bbl / Day)

	UBits v88a:10;				// Oil - imports (bbl / Day)
	UBits v88b:3;				// Oil - imports (bbl / Day)
	UBits v89a:10;				// Oil - production (bbl / Day)
	UBits v89b:3;				// Oil - production (bbl / Day)
	UBits v90b:3;				// Oil - proved reserves (bbl)
	UBits v92b:3;				// Internet hosts

	UBits v90a:10;				// Oil - proved reserves (bbl)
	UBits v91a:10;				// Armed Forces Personnel
	UBits v91b:1;				// Armed Forces Personnel
	UBits v92a:10;				// Internet hosts
	UBits v96b:1;				// Television broadcast stations

	UBits v93a:10;				// Internet users
	UBits v94a:10;				// Telephones - main lines in use
	UBits v95a:10;				// Telephones - mobile cellular

	UBits c7a:5, c7b:5, c7c:5;	// Currency
	UBits v96a:10;				// Television broadcast stations

	// SIGNED
	SBits v03a:11;				// Lowest point (m)
	SBits v23a:11;				// Net migration per year
	SBits v23b:4;				// Net migration per year
	SBits v33b:4;				// Urban population growth

	SBits v33a:11;				// Urban population growth
	SBits v64:11;				// GDP - real growth rate(%)
	SBits v93b:4;				// Internet users
	SBits v94b:4;				// Telephones - main lines in use

	SBits v65:11;				// Industrial production growth rate (%)
	SBits v66:11;				// Inflation rate (consumer prices) (%)
	SBits v95b:4;				// Telephones - mobile cellular
	SBits d5h:6;				// Timezone (hours)
}
MAPNUMPACKED;

// Macro heaven!
#define NA			1023
#define DD(a)		(#@a-'@')
#define D2(a,b)		DD(a),DD(b)
#define D3(a,b,c)	DD(a),DD(b),DD(c)
#define V(a,b)		a,b
#define VaV(a,b)	a
#define VbV(a,b)	b
#define DATA(c1,c2,c3,c4,c5,c6,c7,d1,d2,d3,d4,d5h,d5m,\
			 v01,v02,v03,v04,v05,v06,v07,v08,v09,v10,v11,v12,v13,v14,v15,v16,v17,v18,v19,v20,\
			 v21,v22,v23,v24,v25,v26,v27,v28,v29,v30,v31,v32,v33,v34,v35,v36,v37,v38,v39,v40,\
			 v41,v42,v43,v44,v45,v46,v47,v48,v49,v50,v51,v52,v53,v54,v55,v56,v57,v58,v59,v60,\
			 v61,v62,v63,v64,v65,v66,v67,v68,v69,v70,v71,v72,v73,v74,v75,v76,v77,v78,v79,v80,\
			 v81,v82,v83,v84,v85,v86,v87,v88,v89,v90,v91,v92,v93,v94,v95,v96) \
	c1,c2,d5m,\
	c3,c4,d1,d3,\
	c5,c6,Colour_##d4,\
	d2,v01,Va##v02,\
	Vb##v02,Vb##v03,Va##v04,Va##v05,Va##v06,\
	Vb##v04+3,Vb##v05,Vb##v06+2,v07,v08+2,\
	Va##v09,Va##v11,v12,\
	Vb##v11+2,Va##v13,Va##v14,Va##v15,\
	Vb##v09+2,Vb##v13,Va##v17,Va##v18,Vb##v21,Vb##v22,\
	Vb##v18+4,Va##v20,Va##v21,Va##v22,Vb##v38,\
	Va##v25,Va##v26,Va##v27,Vb##v31+2,\
	Va##v28,Va##v29,Va##v31,Vb##v42,\
	Va##v32,Va##v34,Va##v35,Vb##v39,Vb##v41,\
	Vb##v34,Va##v36,Va##v38,Vb##v48-5,Vb##v49-5,Vb##v51-4,\
	Va##v39,Va##v40,Va##v41,Vb##v43,\
	Va##v42,Va##v43,v44-1,\
	v45,Va##v46,Va##v47,\
	Va##v48,Va##v49,Vb##v52-3,Vb##v53-3,Vb##v55-5,Vb##v56-5,\
	Va##v51,Va##v52,Vb##v57-5,Vb##v58-5,Vb##v59-3,Vb##v60-3,\
	Va##v53,Va##v55,Vb##v67,Vb##v71,Vb##v73,Vb##v74,\
	Va##v56,Va##v57,Va##v58,\
	Va##v59,Va##v60,Va##v61,\
	Va##v62,Va##v67,Va##v68,\
	Va##v69,Va##v71,Va##v72,\
	Va##v73,Va##v74,Va##v75,\
	Vb##v75,Va##v76,v77-3,Vb##v78-1,Vb##v79-1,\
	Va##v78,Va##v79,Vb##v80-3,Vb##v81-2,Vb##v82-2,Vb##v83-2,\
	Va##v80,Va##v81,Va##v82,\
	Va##v83,v84-2,Vb##v85-4,Vb##v86,Vb##v87,\
	Va##v85,Va##v86,Va##v87,\
	v88,v89,Vb##v90-2,Vb##v92,\
	Va##v90,v91-3,Va##v92,Vb##v96,\
	Va##v93,Va##v94,Va##v95,\
	c7,Va##v96,\
	Va##v03,v23,Vb##v33,\
	Va##v33,Va##v64,Vb##v93,Vb##v94,\
	Va##v65,Va##v66,Vb##v95,d5h

#define COUNTRY(a,b,d) { d },

enum Colour
{
	Colour_B = 0, Colour_G, Colour_Y, Colour_R
};

// Load the data
static const MAPNUMPACKED raw_packed[] =
{
#include "MapTable.h"
};

// Free up unused macros
#undef DATA
#undef D3
#undef D2
#undef DD
#undef NA

enum Unit
{
	Unit_None = 0,				// A
	Unit_Text,					// B
	Unit_Metre,					// C
	Unit_Kilometre,				// D
	Unit_KilometreSq,			// E
	Unit_Capita,				// F
	Unit_CapitaPerYear,			// G
	Unit_Year,					// H
	Unit_Percent,				// I
	Unit_MillionDollar,			// J
	Unit_MalePerFemale,			// K
	Unit_ChildrenPerFemale,		// L
	Unit_GigawattHour,			// M
	Unit_PerThousand,			// N
	Unit_KilometreCuPerYear,	// O
	Unit_KilometreCu,			// P
	Unit_MetreCu,				// Q
	Unit_BillionBarrels,		// R
	Unit_Statistic,				// S
	Unit_TimeZone,				// T
	Unit_Count
};

#define COLUMN(heading, unit, width)		_T(unit) _T(#width) _T(heading) _T("\0")
#define COLUMN_(heading, unit, width, def)	_T(unit) _T(def) _T("\0") _T(#width) _T(heading) _T("\0")
#define COLUMNS \
	COLUMN_("Flag", "B", 0, "") \
	COLUMN ("Country Name", "B", 9) \
	COLUMN_("Statistic", "S", 7, "") \
	COLUMN ("ISO/2", "B", 1) \
	COLUMN ("ISO/3", "B", 1) \
	COLUMN ("FIPS", "B", 1) \
	COLUMN ("IANA", "B", 1) \
	COLUMN ("UN Vehicle", "B", 1) \
	COLUMN ("IOC", "B", 1) \
	COLUMN ("Currency", "B", 1) \
	COLUMN ("Visited", "B", 1) \
	COLUMN_("ISO", "A", 1, "") \
	COLUMN ("ITU Calling", "B", 2) \
	COLUMN_("TZ", "T", 2, "") \
	COLUMN_("Population: Total", "F", 7, "") \
	COLUMN ("Population: 0-14 yrs", "F", 6) \
	COLUMN ("Population: 15-64 yrs", "F", 6) \
	COLUMN ("Population: 65+ yrs", "F", 6) \
	COLUMN_("Life Expectancy at Birth", "H", 1, "yrs") \
	COLUMN ("Median Age", "H", 1) \
	COLUMN_("Probability Reaching 65: Female", "I", 2, "%") \
	COLUMN ("Probability Reaching 65: Male", "I", 2) \
	COLUMN_("Births", "G", 5, "pa") \
	COLUMN ("Deaths", "G", 5) \
	COLUMN ("Net Migration", "G", 5) \
	COLUMN ("Population Growth", "G", 5) \
	COLUMN_("Sex Ratio: At Birth", "K", 1, "m/f") \
	COLUMN ("Sex Ratio: 0-14 yrs", "K", 1) \
	COLUMN ("Sex Ratio: 15-64 yrs", "K", 1) \
	COLUMN ("Sex Ratio: 65+ yrs", "K", 1) \
	COLUMN ("Sex Ratio: Total Population", "K", 2) \
	COLUMN_("Infant Mortality", "N", 5, "/1000") \
	COLUMN_("Total Fertility Rate", "L", 1, "c/f") \
	COLUMN ("Urban Population Growth", "G", 5) \
	COLUMN ("Urban Population", "F", 6) \
	COLUMN ("HIV/AIDS Adults Infected", "F", 6) \
	COLUMN_("Coastline", "D", 3, "km") \
	COLUMN_("Highest Point", "C", 2, "m") \
	COLUMN ("Lowest Point", "C", 2) \
	COLUMN_("Total Freshwater Withdrawal", "O", 5, "km/yr") \
	COLUMN_("Irrigated Land", "E", 5, "km") \
	COLUMN ("Land Area", "E", 8) \
	COLUMN ("Land Boundaries", "D", 3) \
	COLUMN ("Land Use: Arable", "E", 8) \
	COLUMN ("Land Use: Permanent Crops", "E", 8) \
	COLUMN ("Land Use: Other", "E", 8) \
	COLUMN_("Total Renewable Water Resources", "P", 5, "km") \
	COLUMN ("Water Area", "E", 3) \
	COLUMN ("Airports: Paved", "A", 2) \
	COLUMN ("Airports: Unpaved", "A", 2) \
	COLUMN ("Airports: Total", "A", 2) \
	COLUMN ("Heliports", "A", 2) \
	COLUMN ("Merchant Marine Ships", "A", 2) \
	COLUMN ("Pipelines", "D", 3) \
	COLUMN ("Railways", "D", 3) \
	COLUMN ("Roadways", "D", 3) \
	COLUMN ("Waterways", "D", 3) \
	COLUMN ("Primary School Attendance", "I", 2) \
	COLUMN ("Literacy", "I", 2) \
	COLUMN_("Budget Expenditures", "J", 9, "US$") \
	COLUMN ("Budget Revenues", "J", 9) \
	COLUMN ("Budget Surplus", "J", :) \
	COLUMN ("External Debt", "J", >) \
	COLUMN ("Imports", "J", 9) \
	COLUMN ("Exports", "J", 9) \
	COLUMN ("Balance of Payments", "J", 9) \
	COLUMN ("GDP: Official Exchange Rate", "J", :) \
	COLUMN ("GDP: Purchasing Power Parity", "J", :) \
	COLUMN ("Public Dept", "J", 9) \
	COLUMN ("Reserves of Foreign Exchange and Gold", "J", 9) \
	COLUMN ("Military Expenditures", "J", 9) \
	COLUMN ("Education Expenditures", "J", 9) \
	COLUMN ("GDP by Sector: Agriculture", "J", :) \
	COLUMN ("GDP by Sector: Industry", "J", :) \
	COLUMN ("GDP by Sector: Services", "J", :) \
	COLUMN ("GDP Real Growth Rate", "I", 2) \
	COLUMN ("Industrial Production Growth Rate", "I", 2) \
	COLUMN ("Consumer Price Inflation Rate", "I", 2) \
	COLUMN ("Labour Force: Total", "F", 5) \
	COLUMN ("Labour Force: Agriculture", "F", 5) \
	COLUMN ("Labour Force: Industry", "F", 5) \
	COLUMN ("Labour Force: Services", "F", 5) \
	COLUMN ("Population Below Poverty Line", "F", 5) \
	COLUMN ("Unemployment Rate", "I", 2) \
	COLUMN ("Manpower Available for Military Service", "F", 5) \
	COLUMN ("Manpower Fit for Military Service", "F", 5) \
	COLUMN ("Manpower Reaching Military Age", "G", 5) \
	COLUMN ("Armed Forces Personnel", "F", 5) \
	COLUMN ("Human Development Index", "A", 2) \
	COLUMN_("Electricity: Consumption", "M", 9, "kWh") \
	COLUMN ("Electricity: Exports", "M", :) \
	COLUMN ("Electricity: Imports", "M", 9) \
	COLUMN ("Electricity: Production", "M", 9) \
	COLUMN_("Natural Gas: Consumption", "Q", 8, "m") \
	COLUMN ("Natural Gas: Exports", "Q", 8) \
	COLUMN ("Natural Gas: Imports", "Q", 8) \
	COLUMN ("Natural Gas: Production", "Q", 8) \
	COLUMN ("Natural Gas: Proved Reserves", "Q", :) \
	COLUMN_("Oil: Consumption", "R", 6, "bbl/day") \
	COLUMN ("Oil: Exports", "R", 6) \
	COLUMN ("Oil: Imports", "R", 6) \
	COLUMN ("Oil: Production", "R", 6) \
	COLUMN ("Oil: Proved Reserves", "R", 8) \
	COLUMN ("Internet: Hosts", "A", 5) \
	COLUMN ("Internet: Users", "F", 5) \
	COLUMN ("Telephones: Main Lines", "A", 5) \
	COLUMN ("Telephones: Cellular", "A", 5) \
	COLUMN ("Television Broadcast Stations", "A", 2)
